*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\DLT\\HBDLT.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Procedure Main()
*+               Static Procedure DLTstart()
*+               Create Class DemoForm()
*+               Static Function OpenDLTSETUP()
*+               Static Procedure CloseDLTSETUP()
*+               Static Procedure DoEndObj()
*+               Static Function CRE_POINTS()
*+               Static Function CRE_RIBS()
*+               Static Function CRE_TRIANGLE()
*+               Static Function CRE_TRIPLEMEMO()
*+               Static Function CRE_Setup()
*+               Static Function RGB_COLOR()
*+               Static Function Winkel()
*+               Static Function GraSaveScreen()
*+               Static Procedure GraRestScreen()
*+               Static Function VAR2CHAR()
*+               Static Procedure SbarText()
*+               Static Function onDummy()
*+               Static Function RGB2Num()
*+               Static Function RGB2BGR()
*+               Static Function NumColor2RGB()
*+
*+       Tables: USE TRIMEMO.DBF EXCLUSIVE VIA "DBFCDX"
*+               USE TPOINTS.DBF EXCLUSIVE VIA "DBFCDX"
*+               USE TRIANGLE.DBF EXCLUSIVE VIA "DBFCDX"
*+               USE RIBS.DBF EXCLUSIVE VIA "DBFCDX"
*+               USE DLTSETUP.DBF ALIAS DLTSETUP EXCLUSIVE
*+               USE DLTSETUP.DBF EXCLUSIVE
*+
*+    Reformatted by Click! 2.05.30 on Jun-29-2020 at 12:05 am
*+
*+--------------------------------------------------------------------

#include "HMG.ch"
#include "hbclass.ch"

#include "Common.ch"
#include "Font.ch"
#include "DLL.ch"

// simulate PAS Syntax for Array Element
//

// TTPoint=record
//   x,y:integer;
//
#xtranslate .x          => \[1\]
#xtranslate .y          => \[2\]
#xtranslate .z          => \[3\]
#xtranslate .Color      => \[4\]

// TCircle=record
//   xo,yo,R:single;
//
#xtranslate .xo         => \[1\]
#xtranslate .yo         => \[2\]
#xtranslate .R          => \[3\]

// TRib=record
//   p1,p2:integer;
//
#xtranslate .p1         => \[1\]
#xtranslate .p2         => \[2\]

// TTriangle=record
//   p1,p2,p3:integer;
//
#xtranslate .gx         => \[1\]
#xtranslate .yy         => \[2\]
#xtranslate .zz         => \[3\]

// Gradient
//
//
#xtranslate .Red        => \[3\]
#xtranslate .Green      => \[4\]
#xtranslate .Blue       => \[5\]
#xtranslate .Alpha      => \[6\]

#xtranslate .Vertex1    => \[1\]
#xtranslate .Vertex2    => \[2\]
#xtranslate .Vertex3    => \[3\]

//  ------------------------------------------------------------------------- *

#DEFINE nMaxPoints      100
#DEFINE CRLF            CHR(13)+CHR(10)
#DEFINE false           .F.
#DEFINE true            .T.
#DEFINE AO_PATCH1       .T.
#DEFINE nPi             3.14159265358979323846

//  ------------------------------------------------------------------------- *

REQUEST DBFCDX
REQUEST DBFNTX

STATIC lDebug := .T.

MEMVAR _HMG_SYSDATA
MEMVAR oDemoForm, lDemoRun

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main()

LOCAL i, iMax := PCOUNT()
LOCAL cPara        := ""
LOCAL lHelp        := .F.
LOCAL lFlagCircle  := .F.                                             // show solve Circle
LOCAL lFlagEdge    := .F.                                             // use 4 Points on Edge
LOCAL lRibQuick    := .F.                                             // try quick 1st Ribs
LOCAL lFlagSmooth  := .F.                                             // Gradient other Color ... hm
LOCAL nPointsCount := 0
LOCAL nStep, nCpu

PUBLIC oDemoForm, lDemoRun := .F.

   // check Parameter
   //
   IF imax > 0
      FOR i := 1 TO iMax
         cPara := PValue( i )
         DO CASE
            CASE ( SUBSTR( cPara, 1, 2 ) = "/P" .OR. SUBSTR( cPara, 1, 2 ) = "/p" )
               nPointsCount := VAL( SUBSTR( cPara, 3, LEN( cPara ) - 2 ) )

            CASE ( SUBSTR( cPara, 1, 2 ) = "/C" .OR. SUBSTR( cPara, 1, 2 ) = "/c" )
               lFlagCircle := .T.

            CASE ( SUBSTR( cPara, 1, 2 ) = "/S" .OR. SUBSTR( cPara, 1, 2 ) = "/s" )
               lFlagSmooth := .T.

            CASE ( SUBSTR( cPara, 1, 2 ) = "/E" .OR. SUBSTR( cPara, 1, 2 ) = "/e" )
               lFlagEdge := .T.

            CASE ( SUBSTR( cPara, 1, 2 ) = "/Q" .OR. SUBSTR( cPara, 1, 2 ) = "/q" )
               lRibQuick := .T.

            OTHERWISE
               lHelp := .T.
         ENDCASE
      NEXT
      IF lHelp = .T.
         MSGInfo( "Syntax : DLT.EXE </Pgxx> </C> </S> </E> </Q>" + CRLF + CRLF + ;
                  "/P Number Points" + CRLF + ;
                  "/C Show Circle" + CRLF + ;
                  "/S smooth Gradient (other Color)" + CRLF + ;
                  "/E add 4 Points on Edge" + CRLF + ;
                  "/Q try Quick 1st Ribs ( need /E )" + CRLF + ;
                  "Sample : DLT.EXE /P51 /E /Q", "Error Parameter" )

      ENDIF
   ENDIF

   IF lDebug = .T.
      SET ALTER TO ( "_LOGIT2.TXT" )
   ENDIF

   IF !FILE( "DLTSETUP.DBF" )
      CRE_Setup( "DLTSETUP.DBF" )
   ENDIF

   // **************************************************************************

   DEFINE WINDOW MainForm ;
              AT 0, 0 ;
              WIDTH 1024 ;
              HEIGHT 768 ;
              TITLE "harbour Delaunay Triangulation 64bit" ;
              ICON "A1MAIN" ;
              ON INIT DLTstart( lFlagCircle, lFlagSmooth, lFlagEdge, lRibQuick, nPointsCount ) ;
              ON RELEASE DoEndObj() ;
              ON SIZE Nil ;
              ON MAXIMIZE Nil ;
              ON MINIMIZE Nil ;
              ON MOUSECLICK oDemoForm:ShowColor() ;
              ON PAINT nil ;                                          // IF(lDemoRun = .T., oDemoForm:xOnPaint(ThisWindow.Handle), NIL) ;
              BACKCOLOR Nil                                           //  {56,56,56}

      DEFINE STATUSBAR PARENT MainForm
         STATUSITEM "ready"

         //  KEYBOARD WIDTH 100
         DATE WIDTH 100
         CLOCK WIDTH 100
      END STATUSBAR

      DEFINE CONTEXT MENU OF MainForm
         MENUITEM "&Setup" ACTION oDemoForm:DoSetup()
         SEPARATOR
         MENUITEM "&Gen Points" ACTION oDemoForm:GenPoints( .T. )
         MENUITEM "&Triangulation" ACTION oDemoForm:Triangulation( .F. )
         MENUITEM "&Repaint Ribs" ACTION oDemoForm:RepaintRibs()
         MENUITEM "&DrawGradient" ACTION oDemoForm:DrawGradient()
         SEPARATOR
         MENUITEM "Save &Bitmap" ACTION oDemoForm:SaveBitmap()
         SEPARATOR
         MENUITEM "s&ave Points" ACTION oDemoForm:SavePoints()
      END MENU

   END WINDOW

   CENTER WINDOW MainForm
   ACTIVATE WINDOW MainForm

   IF lDebug = .T.
      SET ALTER TO
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DLTstart()
*+
*+    Called from ( hbdlt.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DLTstart( lFlagCircle, lFlagSmooth, lFlagEdge, lRibQuick, nPointsCount )

LOCAL ii, iMax, aStruct, aLine

   oDemoForm := DemoForm() :New()
   oDemoForm:InitFromDBF()

   IF lFlagCircle = .T.
      oDemoForm:lFlagCircle := .T.
   ENDIF
   IF lFlagSmooth = .T.
      oDemoForm:lFlagSmooth := .T.
   ENDIF
   IF lFlagEdge = .T.
      oDemoForm:lFlagEdge := .T.
   ENDIF
   IF lRibQuick = .T.
      oDemoForm:lRibQuick := .T.
   ENDIF
   IF nPointsCount > 0
      oDemoForm:SetMaxPoints( nPointsCount )
   ENDIF

   oDemoForm:OnInit()

   lDemoRun := .T.
   oDemoForm:GenPoints( .T. )

RETURN


*+--------------------------------------------------------------------
*+
*+    Create Class DemoForm()
*+
*+    Called from ( hbdlt.prg )   1 - static procedure dltstart()
*+
*+--------------------------------------------------------------------
*+
CREATE CLASS DemoForm

   HIDDEN:
   VAR UserPoints
   VAR nTrySolve
   VAR nFFRib
   VAR aDupe

   VAR aRibID
   VAR aTriangleID
   VAR aRibsSide
   VAR nRibID
   VAR nTriangleID

   VAR oSaveScreen
   VAR lRunning

   EXPORTED:
   METHOD New()
   METHOD OnInit()
   METHOD Destroy()
   METHOD VERSION()
   METHOD FindPoint()
   METHOD SolveCircle()
   METHOD FindFirstRib()
   METHOD Side()
   METHOD TriangleExists()
   METHOD Triangulation()
   METHOD GenPoints()
   METHOD ClearImage()
   METHOD Circle()
   METHOD Line()
   METHOD DrawGradient()
   METHOD DrawTriangleGradient()
   METHOD ShowColor()
   METHOD RepaintRibs()
   METHOD SavePoints()
   METHOD SaveBitmap()
   METHOD TimeGlassOn()
   METHOD TimeGlassOff()
   METHOD Distance()
   METHOD RibExists()
   METHOD SetMaxPoints()
   METHOD xOnPaint()
   METHOD DoSetup()
   METHOD InitFromDBF()
   METHOD FindDistance()

   VAR apoints
   VAR pointsCount
   VAR Triangles
   VAR TrianglesCount
   VAR Ribs
   VAR RibsCount
   VAR lFlagCircle
   VAR lFlagSmooth
   VAR lFlagEdge
   VAR lRibQuick
   VAR lbreak
   VAR aDistance
   VAR colorrightleft

   ENDCLASS

METHOD VERSION() CLASS DemoForm

RETURN "v0.04"

METHOD New( oParent, oOwner, aPos, aSize, aPP, lVisible ) CLASS DemoForm

   ::pointsCount := nMaxPoints
   ::apoints := {}
   ::lFlagCircle := .F.                                               // solve Circle
   ::nTrySolve := 0                                                   // solve Counter
   ::lFlagEdge := .F.                                                 // add 4 Points at Edge
   ::nFFRib := 0                                                      // time find frist Ribs
   ::aDupe := {}                                                      // aviod Dupe
   ::lFlagSmooth := .F.
   ::colorrightleft := .F.                       // unused

   // new v2
   ::aRibID := {}
   ::aTriangleID := {}
   ::aRibsSide := {}
   ::lRibQuick := .F.

RETURN self

METHOD OnInit() CLASS DemoForm

   // save if User have change default 100 Points to generate
   ::UserPoints := ::pointsCount

   ::RibsCount := 0
   ::Ribs := ARRAY( ::pointsCount * 6, 2 )
   AFILL( ::Ribs.x, 0 )
   AFILL( ::Ribs.y, 0 )

   ::TrianglesCount := 0
   ::Triangles := ARRAY( ::pointsCount * 3, 3 )
   AFILL( ::Triangles.gx, 0 )
   AFILL( ::Triangles.yy, 0 )
   AFILL( ::Triangles.zz, 0 )

   ::aRibsSide := ARRAY( ::pointsCount * 6 )
   AFILL( ::aRibsSide, 0 )

   ::lRunning := .F.
   ::lbreak := .F.

   ::aDistance := ARRAY( ::pointsCount, ::pointsCount )

RETURN self

METHOD Destroy() CLASS DemoForm

RETURN Self

METHOD FindPoint( nRib ) CLASS DemoForm

LOCAL nMin := 1000000000
LOCAL i    := 1
LOCAL j    := 1
LOCAL cr
LOCAL b
LOCAL x2, y2, v := 0
LOCAL nRet := - 1
LOCAL ll
LOCAL oSide
LOCAL nSide
LOCAL nRiSi
LOCAL aPoints      := ::apoints
LOCAL nPointsCount := ::PointsCount
LOCAL aRibs        := ::Ribs
LOCAL aRibsSide    := ::aRibsSide
LOCAL r1           := aRibs[ nRib ] .p1
LOCAL r2           := aRibs[ nRib ] .p2

   IF r1 = NIL
      RETURN ( 0 )
   ENDIF
   IF r2 = NIL
      RETURN ( 0 )
   ENDIF

   IF EMPTY( nRib )
      ALTD()
   ENDIF

#IFDEF AO_PATCH1
   IF ASCAN( ::aDupe, { | x | x[ 1 ] = r1 .AND. x[ 2 ] = r2 } ) > 0
      RETURN ( 0 )
   ELSE
      AADD( ::aDupe, { r1, r2 } )
   ENDIF
#ENDIF


   FOR i := 1 TO nPointsCount
      IF i <> r1 .AND. i <> r2
         IF .NOT. ::TriangleExists( r1, r2, i )
            nSide := ::Side( r1, r2, aPoints[ i ] .x, aPoints[ i ] .y )
            nRiSi := aRibsSide[ nRib ]
            IF nSide = nRiSi

               cr := ::SolveCircle( aPoints[ r1 ] .x, aPoints[ r1 ] .y, ;
                                    aPoints[ r2 ] .x, aPoints[ r2 ] .y, ;
                                    aPoints[ i ] .x, aPoints[ i ] .y )

               x2 := cr.xo - ( aPoints[ r1 ] .x + aPoints[ r2 ] .x ) * 0.5
               y2 := cr.yo - ( aPoints[ r1 ] .y + aPoints[ r2 ] .y ) * 0.5

               ll := SQRT( x2 * x2 + y2 * y2 )

               oSide := ::side( r1, r2, cr.xo, cr.yo )

               IF oSide = aRibsSide[ nRib ]
                  v := cr.R + ll
               ELSE
                  v := cr.R - ll
               ENDIF

               IF ( v > 1 ) .AND. ( v < nMin )
                  IF v = nMin
                     EXIT
                  ELSE
                     nMin := v
                     nRet := i
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      DO EVENTS

   NEXT

RETURN nRet

METHOD SolveCircle( x1, y1, x2, y2, x3, y3 ) CLASS DemoForm

LOCAL maa, mbb, dx1, dy1, dx2, dy2, dmm
LOCAL aRet := { 0, 0, 0 }                                             // TCircle

   dx1 := x2 - x1
   dy1 := y2 - y1
   dx2 := x3 - x2
   dy2 := y3 - y2
   IF ABS( dx1 ) < 0.01
      x1 := x1 - 0.1
      dx1 := x2 - x1
   ENDIF
   IF ABS( dx2 ) < 0.01
      x3 := x3 + 0.1
      dx2 := x3 - x2
   ENDIF
   IF ABS( dy1 ) < 0.01
      y1 := y1 - 0.1
      dy1 := y2 - y1
   ENDIF
   IF ABS( dy2 ) < 0.01
      y3 := y3 + 0.1
      dy2 := y3 - y2
   ENDIF
   maa := dy1 / dx1
   mbb := dy2 / dx2
   dmm := mbb - maa
   IF ABS( dmm ) < 0.0000001
      y3 := y3 + 0.1
      dy2 := y3 - y2
      mbb := dy2 / dx2
      dmm := mbb - maa
   ENDIF
   aRet.xo := ( maa * mbb * ( y1 - y3 ) + mbb * ( x1 + x2 ) - maa * ( x2 + x3 ) ) * 0.5 / dmm
   aRet.yo := - 1 / mbb * ( aRet.xo - ( x2 + x3 ) * 0.5 ) + ( y2 + y3 ) * 0.5
   dx1 := x1 - aRet.xo
   dy1 := y1 - aRet.yo
   aRet.R := SQRT( dx1 * dx1 + dy1 * dy1 )

   ::nTrySolve ++

RETURN aRet

METHOD FindFirstRib() CLASS DemoForm

LOCAL aTest
LOCAL agxX
LOCAL ngxX
LOCAL nDif
LOCAL P2           := 0
LOCAL P1           := 0
LOCAL aColor1
LOCAL aColor2
LOCAL i, j, k, n
LOCAL st_1, st_0
LOCAL nRibsCount   := 0
LOCAL aPoints      := ::aPoints
LOCAL nPointsCount := ::pointsCount
LOCAL aRibs        := ::Ribs
LOCAL nStart       := SECONDS()

   IF ::lRibQuick = .T.
      aTest := ACLONE( ::aPoints )
      aTest := ASORT( aTest,,, { | aX, aY | STR( aX[ 1 ] ) + STR( aX[ 2 ] ) < STR( aY[ 1 ] ) + STR( aY[ 2 ] ) } )
      ngxX := aTest[ 1 ] [ 1 ]
      nDif := 0

      FOR i := 1 TO nPointsCount
         IF aTest[ i ] [ 1 ] <> ngxX
            EXIT
         ENDIF
         IF aTest[ i ] [ 2 ] > nDif
            nDif := aTest[ i ] [ 2 ]
            P2 := i
         ENDIF
      NEXT
      DO EVENTS

      aRibs[ 1 ] .p2 := aTest[ P2 ] [ 3 ]                             // { Minx,MaxY }
      aColor2 := aTest[ P2 ] .Color

      aTest := ASORT( aTest,,, { | aX, aY | STR( aX[ 2 ] ) + STR( aX[ 1 ] ) > STR( aY[ 2 ] ) + STR( aY[ 1 ] ) } )
      ngxX := aTest[ 1 ] [ 2 ]
      nDif := 0

      FOR i := 1 TO nPointsCount
         IF aTest[ i ] [ 2 ] <> ngxX
            EXIT
         ENDIF
         IF aTest[ i ] [ 1 ] > nDif
            nDif := aTest[ i ] [ 1 ]
            P1 := i
         ENDIF
      NEXT
      DO EVENTS

      aRibs[ 1 ] .p1 := aTest[ P1 ] [ 3 ]                             // { Magx,MaxY }
      aColor1 := aTest[ P1 ] .Color

      ::aRibsSide[ 1 ] := 1

      ::RibsCount := 1

      ::Line( aPoints[ aRibs[ 1 ] .p1 ] .x, aPoints[ aRibs[ 1 ] .p1 ] .y, ;
              aPoints[ aRibs[ 1 ] .p2 ] .x, aPoints[ aRibs[ 1 ] .p2 ] .y, RED )

      // MSGInfo(var2char(aPoints[aRibs[1].p1])+" "+var2char(aPoints[aRibs[1].p2]))
      aTest := {}

   ELSE /* -------------------- Old Code --------------------------------- */

      FOR i := 1 TO ( nPointsCount ) - 1                              // 1000
         FOR j := i + 1 TO nPointsCount                               // 1000*1000
            st_1 := false
            st_0 := false
            FOR k := 1 TO nPointsCount                                // 1000*1000*1000 ... hm
               IF ( k <> i ) .AND. ( k <> j )
                  n := ::Side( i, j, aPoints[ k ] .x, aPoints[ k ] .y )

                  IF n = 1
                     st_1 := true
                  ENDIF
                  IF n = 0
                     st_0 := true
                  ENDIF
               ENDIF
            NEXT
            DO EVENTS

            IF .NOT. ( st_1 .AND. st_0 )
               ::Ribs[ 1 ] .p1 := i
               ::Ribs[ 1 ] .p2 := j
               ::RibsCount := 1

               ::aRibsSide[ 1 ] := n

               nRibsCount ++

               ::Line( aPoints[ i ] .x, aPoints[ i ] .y, aPoints[ j ] .x, aPoints[ j ] .y, RED )
               //               MSGInfo(var2char(aPoints[i])+" "+var2char(aPoints[j]))
               EXIT
            ENDIF
         NEXT
         DO EVENTS
      NEXT
      DO EVENTS

   ENDIF

   ::nFFRib := SECONDS() - nStart
   SbarText( "1st RIB " + STR( ::nFFRib ) + " Sec." )

RETURN NIL

METHOD Side( i, j, xo, yo ) CLASS DemoForm

LOCAL x1, y1, x2, y2, dx, dy, a, b, v
LOCAL nRet    := - 1
LOCAL aPoints := ::aPoints

   IF EMPTY( i ) .OR. EMPTY( j )
      RETURN nRet
   ENDIF

   x1 := aPoints[ i ] .x
   y1 := aPoints[ i ] .y
   x2 := aPoints[ j ] .x
   y2 := aPoints[ j ] .y

   dx := x2 - x1
   dy := y2 - y1
   IF ABS( dx ) > ABS( dy )
      a := dy / dx
      b := y1 - a * x1
      v := a * xo + b
      nRet := IF( yo > v, 0, 1 )
   ELSE
      a := dx / dy
      b := x1 - a * y1
      v := a * yo + b
      nRet := IF( xo > v, 0, 1 )
   ENDIF

RETURN nRet

METHOD RibExists( p1, p2 ) CLASS DemoForm                             // new v2

LOCAL ar := {}

   IF ::RibsCount = 0
      RETURN ( .F. )
   ELSE
      AADD( ar, ALLTRIM( STR( p1 ) ) )
      AADD( ar, ALLTRIM( STR( p2 ) ) )
      ASORT( ar )
      ::nRibID := STRTRAN( ar[ 1 ] + ar[ 2 ], ' ', '_' )

      IF ASCAN( ::aRibID, ::nRibID ) = 0
         RETURN ( .F. )
      ELSE
         RETURN ( .T. )
      ENDIF

   ENDIF

RETURN NIL

METHOD TriangleExists( p1, p2, p3 ) CLASS DemoForm                    // new v2

LOCAL ar := {}

   IF ::TrianglesCount = 0
      RETURN ( .F. )
   ELSE
      AADD( ar, ALLTRIM( STR( p1 ) ) )
      AADD( ar, ALLTRIM( STR( p2 ) ) )
      AADD( ar, ALLTRIM( STR( p3 ) ) )
      ASORT( ar )
      ::nTriangleID := STRTRAN( ar[ 1 ] + ar[ 2 ] + ar[ 3 ], ' ', '_' )

      IF ASCAN( ::aTriangleID, ::nTriangleID ) = 0
         RETURN ( .F. )
      ELSE
         RETURN ( .T. )
      ENDIF
   ENDIF
RETURN NIL

METHOD Triangulation( lChangeCPU ) CLASS DemoForm

LOCAL zzz, p1, p2, nn
LOCAL X1, Y1, X2, Y2, X3, Y3, j
LOCAL nStart
LOCAL nStop
LOCAL nCalcCount := 0
   // use LOCAL instead iVar for Loop
   //
LOCAL aPoints    := ::aPoints
LOCAL aRibs      := ::Ribs
LOCAL aTriangles := ::Triangles
   // New v2
LOCAL aRibsSide := ::aRibsSide

   IF ::lRunning = .T.
      RETURN NIL
   ENDIF
   ::lRunning := .T.

   AFILL( aTriangles.gx, 0 )
   AFILL( aTriangles.yy, 0 )
   AFILL( aTriangles.zz, 0 )

   AFILL( aRibs.x, 0 )
   AFILL( aRibs.y, 0 )

   // new v2
   ::aRibID := {}
   ::aTriangleID := {}
   AFILL( aRibsSide, 0 )

   ::TrianglesCount := 0                                              // reset
   ::nTrySolve := 0                                                   // reset
   ::aDupe := {}                                                      // aviod Dupe

   ::ClearImage()
   SbarText( "Start Triangulation " + TIME() )

   //    ::TimeGlassOn(  )
   nStart := SECONDS()

   ::FindFirstRib()

   zzz := 1
   DO WHILE ( zzz < ::RibsCount + 1 )

      IF ::lbreak = .T.
         EXIT
      ENDIF

      DO EVENTS

      nCalcCount ++

      // check Element
      //
      p1 := aRibs[ zzz ] .p1
      p2 := aRibs[ zzz ] .p2

      // can i use Threads ?
      //
      IF aRibsSide[ zzz ] < 255
         nn := ::FindPoint( zzz )
         //         nn := ::FindDistance(zzz,p1,p2)
      ELSE
         nn := - 1
      ENDIF

      IF nn > 0
         IF ::RibsCount + 1 <= LEN( aRibs )
            aRibs[ ::RibsCount + 1 ] .p1 := p1
            aRibs[ ::RibsCount + 1 ] .p2 := nn
            // new v2
            IF .NOT. ::RibExists( p1, nn )
               aRibsSide[ ::RibsCount + 1 ] := 1 - ::Side( p1, nn, aPoints[ p2 ] .x, aPoints[ p2 ] .y )
               AADD( ::aRibID, ::nRibID )
            ELSE
               aRibsSide[ ::RibsCount + 1 ] := 255
            ENDIF
         ENDIF

         IF ::RibsCount + 2 <= LEN( aRibs )
            aRibs[ ::RibsCount + 2 ] .p1 := p2
            aRibs[ ::RibsCount + 2 ] .p2 := nn
            // new v2
            IF .NOT. ::RibExists( p2, nn )
               aRibsSide[ ::RibsCount + 2 ] := 1 - ::Side( p2, nn, aPoints[ p1 ] .x, aPoints[ p1 ] .y )
               AADD( ::aRibID, ::nRibID )
            ELSE
               aRibsSide[ ::RibsCount + 2 ] := 255
            ENDIF
            ::RibsCount := ::RibsCount + 2
         ENDIF

         // new v2
         IF ASCAN( ::aTriangleID, ::nTriangleID ) = 0
            AADD( ::aTriangleID, ::nTriangleID )
         ENDIF

         ::TrianglesCount ++
         //          IF ::TrianglesCount <= LEN(aTriangles)
         aTriangles[ ::TrianglesCount ] .gx := p1
         aTriangles[ ::TrianglesCount ] .yy := p2
         aTriangles[ ::TrianglesCount ] .zz := nn
         //          ENDIF

         //          ::Line(aPoints[p1].x,aPoints[p1].y,aPoints[nn].x,aPoints[nn].y, aPoints[p1].Color, aPoints[nn].Color)
         //          ::Line(aPoints[p2].x,aPoints[p2].y,aPoints[nn].x,aPoints[nn].y, aPoints[p2].Color, aPoints[nn].Color)
         //          ::Line(aPoints[p1].x,aPoints[p1].y,aPoints[p2].x,aPoints[p2].y, aPoints[p1].Color, aPoints[p2].Color)
         ::Line( aPoints[ p1 ] .x, aPoints[ p1 ] .y, aPoints[ nn ] .x, aPoints[ nn ] .y )
         ::Line( aPoints[ p2 ] .x, aPoints[ p2 ] .y, aPoints[ nn ] .x, aPoints[ nn ] .y )
         ::Line( aPoints[ p1 ] .x, aPoints[ p1 ] .y, aPoints[ p2 ] .x, aPoints[ p2 ] .y )

      ENDIF
      zzz := zzz + 1
   ENDDO

   nStop := SECONDS() - nStart
   //    ::TimeGlassOff(  )
   SbarText( "ready ... " + LTRIM( STR( nStop ) ) + " Sec." )

   // Debug with low Number -> do not show MSGInfo()
   //
   IF ::pointsCount > 50

      SbarText( "ready ... " + LTRIM( STR( nStop ) ) + " Sec. " + ;
                "for " + LTRIM( STR( ::pointsCount ) ) + " Points. Try solve " + LTRIM( STR( ::nTrySolve ) ) )

      //       MSGInfo("ready ... "+LTRIM(STR(nStop))+" Sec."+CRLF+;
      //              "for "+LTRIM(STR(::pointsCount))+ " Points"+CRLF+;
      //              "1st Ribs "+LTRIM(STR(::nFFRib))+" Sec."+CRLF+;
      //              "calc "+LTRIM(STR(nCalcCount))+CRLF+;
      //              "Dupe FindPoint() "+LTRIM(STR(LEN(::aDupe)))+CRLF+;
      //              "TriAngle "+LTRIM(STR(::TrianglesCount))+CRLF+;
      //              "Try solve "+LTRIM(STR(::nTrySolve)),;
      //              "Triangulation()" )
   ENDIF

   ::lRunning := .F.

RETURN NIL

METHOD GenPoints( lNew ) CLASS DemoForm

LOCAL i, j
LOCAL mX, mY
LOCAL aSize           := { 0, 0 }
LOCAL aColor
LOCAL lUseDBF         := .F.
LOCAL aRGB            := RGB_COLOR()
LOCAL iMax            := LEN( aRGB )
LOCAL aCheck          := {}
LOCAL nTrianglesCount := ::TrianglesCount
LOCAL mainWidth       := GetProperty( "MainForm", "ClientAreaWidth" )
LOCAL mainHeight      := GetProperty( "MainForm", "ClientAreaHeight" )
LOCAL nSB, aRect := { 0, 0, 0, 0 }

   IF ::lRunning = .T.
      RETURN NIL
   ENDIF

   nSB := GetControlHandle( "STATUSBAR", "MainForm" )
   IF !EMPTY( nSB )
      GetWindowRect( nSB, @aRect )
   ENDIF
   aSize[ 1 ] := mainWidth
   aSize[ 2 ] := mainHeight - ( aRect[ 4 ] - aRect[ 2 ] )             // -nTitlebar-36

   // do not use internal Edge
   //
   AADD( aCheck, { 0, 0 } )
   AADD( aCheck, { aSize[ 1 ], 0 } )
   AADD( aCheck, { aSize[ 1 ], aSize[ 2 ] } )
   AADD( aCheck, { 0, aSize[ 2 ] } )

   IF FILE( "TRIMEMO.DBF" )

      USE TRIMEMO.DBF EXCLUSIVE VIA "DBFCDX"

      ::apoints := HB_Deserialize( TRIMEMO->TPOINTS )                 // Bin2Var()
      ::Triangles := HB_Deserialize( TRIMEMO->TRIANGLE )              // Bin2Var()

      ::pointsCount := LEN( ::apoints )
      ::TrianglesCount := LEN( ::Triangles )

      CLOSE

      ::ClearImage()
      //    ::TimeGlassOn(  )

      ::lFlagEdge := .T.
      ::lRibQuick := .T.

      FOR i := 1 TO ::PointsCount
         mX := ::apoints[ i ] [ 1 ]
         mY := ::apoints[ i ] [ 2 ]
         aColor := ::apoints[ i ] [ 4 ]

         // use FILL Option
         //
         ::Circle( mX, mY, 3, aColor,, .T. )
      NEXT

      //    ::TimeGlassOff(  )

   ELSE

      IF EMPTY( lNew )
         IF FILE( "TPOINTS.DBF" )
            USE TPOINTS.DBF EXCLUSIVE VIA "DBFCDX"
            ::pointsCount := LASTREC()
            lUseDBF := .T.
         ELSE
            ::pointsCount := MAX( ::UserPoints, ::pointsCount )
            IF ::lFlagEdge = .T.
               ::pointsCount := ::pointsCount - 4
            ENDIF
            lUseDBF := .F.
         ENDIF
      ELSE
         ::pointsCount := MAX( ::UserPoints, ::pointsCount )
         IF ::lFlagEdge = .T.
            ::pointsCount := ::pointsCount - 4
         ENDIF
         lUseDBF := .F.
      ENDIF

      // reset
      //
      ::apoints := {}

      //    AFILL(aTriangles.gx,0)
      //    AFILL(aTriangles.yy,0)
      //    AFILL(aTriangles.zz,0)

      AFILL( ::Ribs.x, 0 )
      AFILL( ::Ribs.y, 0 )

      // new v2
      ::aRibID := {}
      ::aTriangleID := {}
      AFILL( ::aRibsSide, 0 )

      ::ClearImage()

      IF ::pointsCount < 12 .AND. lUseDBF = .F.
         MSGInfo( "less than 12 Points might fail" )
         ::pointsCount := 12

      ELSEIF ::pointsCount > 510
         MSGInfo( "WARNING : " + LTRIM( STR( ::pointsCount ) ) + " Points may take Hours to calculate !" )
      ENDIF

      SbarText( "generate " + LTRIM( STR( ::PointsCount ) ) + " Points" )
      //    ::TimeGlassOn(  )

      FOR i := 1 TO ::PointsCount

         IF lUseDBF = .F.

            // AO_PATCH1
            //
            // check for dupe
            DO WHILE .T.
               mX := hb_RandomInt( aSize[ 1 ] - 2 )
               mY := hb_RandomInt( aSize[ 2 ] - 2 )

               // dupe Check
               //
               IF ASCAN( aCheck, { | X | X[ 1 ] = mX .AND. X[ 2 ] = mY } ) > 0
               ELSE
                  AADD( aCheck, { mX, mY } )
                  EXIT
               ENDIF
            ENDDO
            IF ::lFlagSmooth = .T.
            // aColor := NumColor2RGB( ( 255*255*255 ) - hb_RandomInt( 255*255*255 ) )
               aColor := NumColor2RGB( hb_RandomInt( 255 * 255 * 255 ) )
            ELSE
               aColor := aRGB[ RANDOM(iMax-1)+1 ]
            ENDIF
            DO EVENTS
         ELSE
            mX := TPOINTS->PX
            mY := TPOINTS->PY
            aColor := NumColor2RGB( TPOINTS->COLOR )
         ENDIF
         AADD( ::apoints, { mX, mY, i, aColor } )

         // use FILL Option
         //
         ::Circle( mX, mY, 3, aColor,, .T. )

         IF lUseDBF = .T.
            SKIP
         ENDIF

         DO EVENTS
      NEXT
      aCheck := {}

      ::pointsCount := LEN( ::apoints )

      // hole Screen using Edge Points
      //
      IF ::lFlagEdge = .T. .AND. lUseDBF = .F.
         // fill Screen
         //
         ::pointsCount ++
         AADD( ::apoints, { 0, 0, ::pointsCount, aColor } )
         ::Circle( 0, 0, 3, aColor,, .T. )
         ::pointsCount ++
         AADD( ::apoints, { aSize[ 1 ], 0, ::pointsCount, aColor } )
         ::Circle( aSize[ 1 ], 0, 3, aColor,, .T. )
         ::pointsCount ++
         AADD( ::apoints, { aSize[ 1 ], aSize[ 2 ], ::pointsCount, aColor } )
         ::Circle( aSize[ 1 ], aSize[ 2 ], 3, aColor,, .T. )
         ::pointsCount ++
         AADD( ::apoints, { 0, aSize[ 2 ], ::pointsCount, aColor } )
         ::Circle( 0, aSize[ 2 ], 3, aColor,, .T. )
      ENDIF

      IF lUseDBF = .T.
         CLOSE POINTS

         // restore Triangles
         //
         IF FILE( "TRIANGLE.DBF" )
            USE TRIANGLE.DBF EXCLUSIVE VIA "DBFCDX"

            ::TrianglesCount := LASTREC()
            j := 0

            DO WHILE !EOF()
               j ++
               ::Triangles[ j ] := { TRIANGLE->gx, ;
                                     TRIANGLE->YY, ;
                                     TRIANGLE->ZZ }
               SKIP
            ENDDO
            CLOSE TRIANGLE

         ENDIF

      ELSE
         // sort points to reduce "solve" ???
         //
         IF ::lFlagEdge = .T.
            // **no???*** ::points := ASORT(::apoints,,, {|aX,aY| STR(aX[1])+STR(aX[2]) < STR(aY[1])+STR(aY[2]) } )
         ENDIF
      ENDIF

      //    ::TimeGlassOff(  )

   ENDIF

RETURN NIL

METHOD ClearImage() CLASS DemoForm

   erasewindow( "MainForm" )
RETURN NIL

METHOD Circle( X0, Y0, R0, aColor, nLineType, lFill ) CLASS DemoForm

   onDummy( X0, Y0, R0, aColor, nLineType, lFill )

   IF EMPTY( lFill )
      DRAW ELLIPSE IN WINDOW MainForm at Y0 - 2, X0 - 2 TO Y0 + 2, X0 + 2
   ELSE
      //  DRAW ELLIPSE IN WINDOW MainForm at Y0-1,X0-1 to Y0+1,X0+1 pencolor {random(255),random(255),random(255)} penwidth R0 fillcolor {random(255),random(255),random(255)}
      DRAW ELLIPSE IN WINDOW MainForm at Y0 - 2, X0 - 2 TO Y0 + 2, X0 + 2 pencolor aColor penwidth R0 fillcolor aColor
   ENDIF

   //    RECOVER USING oError
   //       ErrorBlock( bSaveError )
   //       MSGInfo("Error :"+CRLF+;
   //            "X0 "+VAR2CHAR(X0)+CRLF+;
   //            "Y0 "+VAR2CHAR(Y0)+CRLF+;
   //            "R0 "+VAR2CHAR(R0)+CRLF,"Circle")
   //    END SEQUENCE
   //    ErrorBlock( bSaveError )

RETURN nil

METHOD Line( X1, Y1, X2, Y2, aColor1, aColor2, nLineType ) CLASS DemoForm

   DRAW LINE IN WINDOW MainForm AT Y1, X1 TO Y2, X2 PENCOLOR { 1, 1, 1 } PENWIDTH 1
RETURN nil

METHOD DrawGradient() CLASS DemoForm

LOCAL X1, Y1, X2, Y2, X3, Y3, j
LOCAL aColors         := {}
LOCAL aColor1                                                         // := WHITE
LOCAL aColor2                                                         // := WHITE
LOCAL aColor3                                                         // := WHITE
LOCAL nTrianglesCount := ::TrianglesCount
LOCAL aTriangles      := ::Triangles
LOCAL aPoints         := ::aPoints

   // try ::lFlagSmooth
   //
LOCAL ma           := 127
LOCAL mb           := 127
LOCAL mc           := 127
LOCAL mU           := 0
LOCAL mV           := 120
LOCAL mW           := 240
LOCAL mInfMin      := + 999999999999999
LOCAL mInfMax      := - 999999999999999
LOCAL Z1
LOCAL Z2
LOCAL Z3
LOCAL mColor1
LOCAL mColor2
LOCAL mColor3
LOCAL R
LOCAL G
LOCAL B
LOCAL mDeltaSpectr := 90

   // ALTD()
   SbarText( "Start DrawGradient() " + TIME() )

   IF ::colorrightleft

      FOR j := 1 TO nTrianglesCount

         // color right-left
         //
         //   Z1 := aTriangles[j].x
         //   Z2 := aTriangles[j].y
         //   Z3 := aTriangles[j].z

         //   Z1  := aPoints[ aTriangles[j].gx ].Color
         //   Z2  := aPoints[ aTriangles[j].yy ].Color
         //   Z3  := aPoints[ aTriangles[j].zz ].Color

         Z1 := aPoints[ aTriangles[ j ] .gx ] .x
         Z2 := aPoints[ aTriangles[ j ] .yy ] .y
         Z3 := aPoints[ aTriangles[ j ] .zz ] .z

         mInfMin := MIN( Z1, mInfMin )
         mInfMin := MIN( Z2, mInfMin )
         mInfMin := MIN( Z3, mInfMin )

         mInfMax := MAX( Z1, mInfMax )
         mInfMax := MAX( Z2, mInfMax )
         mInfMax := MAX( Z3, mInfMax )
      NEXT
   ENDIF

   FOR j := 1 TO nTrianglesCount

      IF aTriangles[ j ] .gx * aTriangles[ j ] .yy * aTriangles[ j ] .zz = 0
         EXIT
      ELSE

         X1 := aPoints[ aTriangles[ j ] .gx ] .x
         Y1 := aPoints[ aTriangles[ j ] .gx ] .y

         X2 := aPoints[ aTriangles[ j ] .yy ] .x
         Y2 := aPoints[ aTriangles[ j ] .yy ] .y

         X3 := aPoints[ aTriangles[ j ] .zz ] .x
         Y3 := aPoints[ aTriangles[ j ] .zz ] .y

         aColor1 := aPoints[ aTriangles[ j ] .gx ] .Color
         aColor2 := aPoints[ aTriangles[ j ] .yy ] .Color
         aColor3 := aPoints[ aTriangles[ j ] .zz ] .Color

         IF ::colorrightleft

            // other Color ... no Gradient ?
            //
            Z1 := aPoints[ aTriangles[ j ] .gx ] .x
            Z2 := aPoints[ aTriangles[ j ] .yy ] .y
            Z3 := aPoints[ aTriangles[ j ] .zz ] .z

            mColor1 = ABS( INT( mDeltaSpectr + ( 360 - mDeltaSpectr ) * ( Z1 - mInfMin ) / ( mInfMax - mInfMin ) ) )
            R := INT( ma * ( 1 + COS( ( mColor1 + mU ) * nPi / 180 ) ) )
            G := INT( mb * ( 1 + COS( ( mColor1 + mV ) * nPi / 180 ) ) )
            B := INT( mc * ( 1 + COS( ( mColor1 + mW ) * nPi / 180 ) ) )
            aColor1 := { R, G, B }

            mColor2 = ABS( INT( mDeltaSpectr + ( 360 - mDeltaSpectr ) * ( Z2 - mInfMin ) / ( mInfMax - mInfMin ) ) )
            R := INT( ma * ( 1 + COS( ( mColor2 + mU ) * nPi / 180 ) ) )
            G := INT( mb * ( 1 + COS( ( mColor2 + mV ) * nPi / 180 ) ) )
            B := INT( mc * ( 1 + COS( ( mColor2 + mW ) * nPi / 180 ) ) )
            aColor2 := { R, G, B }

            mColor3 = ABS( INT( mDeltaSpectr + ( 360 - mDeltaSpectr ) * ( Z3 - mInfMin ) / ( mInfMax - mInfMin ) ) )
            R := INT( ma * ( 1 + COS( ( mColor3 + mU ) * nPi / 180 ) ) )
            G := INT( mb * ( 1 + COS( ( mColor3 + mV ) * nPi / 180 ) ) )
            B := INT( mc * ( 1 + COS( ( mColor3 + mW ) * nPi / 180 ) ) )
            aColor3 := { R, G, B }

         ENDIF

         aColors := { aColor1, aColor2, aColor3 }
         ::DrawTriangleGradient( "MainForm", { X1, Y1 }, { X2, Y2 }, { X3, Y3 }, aColor1, aColor2, aColor3, 2 )                             // GRA_GRADIENT_TRIANGLE = 2

      ENDIF
   NEXT

   SbarText( "ready DrawGradient() " + STR( nTrianglesCount ) + " Triangles " + TIME() )

RETURN NIL

METHOD DrawTriangleGradient( cForm, aPos, aPos2, aPos3, aColors1, aColors2, aColors3, nDirection ) CLASS DemoForm

LOCAL lRet
LOCAL nHwnd, nHDC

   nHwnd := GetformHandle( cForm )
   IF EMPTY( nHwnd )
      RETURN .F.
   ENDIF

   nHDC := GetDC( nHwnd )

   lRet := GRAGRADIENTEX( nHDC, { aPos[ 1 ], aPos[ 2 ], aColors1[ 1 ], aColors1[ 2 ], aColors1[ 3 ] }, ;
           { aPos2[ 1 ], aPos2[ 2 ], aColors2[ 1 ], aColors2[ 2 ], aColors2[ 3 ] }, ;
           { aPos3[ 1 ], aPos3[ 2 ], aColors3[ 1 ], aColors3[ 2 ], aColors3[ 3 ] } )
   ReleaseDC( nHwnd, nHDC )

RETURN lRet

METHOD ShowColor( aPos ) CLASS DemoForm

LOCAL nColor, aColor
LOCAL aRGB   := { 0, 0, 0 }
LOCAL hWnd, hDC, nPosi

   aPos := { _HMG_SYSDATA[ 191 ], _HMG_SYSDATA[ 192 ] }

   hWnd := GetformHandle( "MainForm" )
   hdc := GetDC( hWnd )
   nColor := GetPixelCOLOR( hDC, aPos[ 2 ], aPos[ 1 ], @aRGB )

   //    MSGInfo("Color "+VAR2CHAR(aRGB),"Position "+VAR2CHAR(aPos) )
   ALTD()
   aColor := GetColor( aRGB )
   IF NIL <> aColor[ 1 ]
      //  SETPIXEL(hDC,aPos[2],aPos[1], aColor )
      //  SETPIXEL(hDC,aPos[1],aPos[2], aColor )

      nPosi := ASCAN( ::aPoints, { | e | aPos[ 2 ] >= e[ 1 ] - 2 .AND. aPos[ 2 ] <= e[ 1 ] + 2 .AND. ;
              aPos[ 1 ] >= e[ 2 ] - 2 .AND. aPos[ 1 ] <= e[ 2 ] + 2 } )
      IF nPosi > 0
         ::aPoints[ nPosi ] .Color := aColor
         ::Circle( aPos[ 2 ], aPos[ 1 ], 3, aColor,, .T. )
      ENDIF
   ENDIF
   ReleaseDC( hWnd, hdc )

RETURN nil

METHOD RepaintRibs() CLASS DemoForm

LOCAL X1, Y1, X2, Y2, X3, Y3, j
LOCAL aColor1, aColor2, aColor3
LOCAL nTrianglesCount := ::TrianglesCount
LOCAL aTriangles      := ::Triangles
LOCAL aPoints         := ::aPoints

   IF ::lRunning = .T.
      RETURN NIL
   ENDIF

   ::ClearImage()

   //    ::TimeGlassOn(  )

   FOR j := 1 TO nTrianglesCount

      IF ::Triangles[ j ] .gx * ::Triangles[ j ] .yy * ::Triangles[ j ] .zz = 0
         EXIT
      ELSE

         X1 := aPoints[ aTriangles[ j ] .gx ] .x
         Y1 := aPoints[ aTriangles[ j ] .gx ] .y
         X2 := aPoints[ aTriangles[ j ] .yy ] .x
         Y2 := aPoints[ aTriangles[ j ] .yy ] .y
         X3 := aPoints[ aTriangles[ j ] .zz ] .x
         Y3 := aPoints[ aTriangles[ j ] .zz ] .y

         aColor1 := aPoints[ aTriangles[ j ] .gx ] .Color
         aColor2 := aPoints[ aTriangles[ j ] .yy ] .Color
         aColor3 := aPoints[ aTriangles[ j ] .zz ] .Color

         ::Circle( X1, Y1, 3, aColor1,, .T. )
         ::Circle( X2, Y2, 3, aColor2,, .T. )
         ::Circle( X3, Y3, 3, aColor3,, .T. )

         //          ::Line(X1,Y1,X2,Y2,aColor1,aColor2)
         //          ::Line(X1,Y1,X3,Y3,aColor1,aColor3)
         //          ::Line(X2,Y2,X3,Y3,aColor2,aColor3)
         ::Line( X1, Y1, X2, Y2 )
         ::Line( X1, Y1, X3, Y3 )
         ::Line( X2, Y2, X3, Y3 )

      ENDIF
   NEXT

   //    ::TimeGlassOff(  )

RETURN NIL

METHOD SaveBitmap() CLASS DemoForm

LOCAL nWidth  := GetProperty( "MainForm", "ClientAreaWidth" )
LOCAL nHeight := GetProperty( "MainForm", "ClientAreaHeight" )
LOCAL nSB, aRect := { 0, 0, 0, 0 }
LOCAL cFile

   nSB := GetControlHandle( "STATUSBAR", "MainForm" )
   IF !EMPTY( nSB )
      GetWindowRect( nSB, @aRect )
   ENDIF
   nHeight -= ( aRect[ 4 ] - aRect[ 2 ] )                             // STATUSBAR

   cFile := GetInPut( "Bitmap", "save Bitmap", "DLT.BMP", 1 )
   IF EMPTY( cFile )
   ELSE
      IF FILE( cFile )
         FERASE( cFile )
      ENDIF
      // snapshot
      Domethod( "MainForm", "Capture", cFile, 0, 0, nWidth, nHeight )
   ENDIF

RETURN NIL

METHOD SavePoints() CLASS DemoForm

LOCAL i, j
LOCAL nTrianglesCount := ::TrianglesCount
LOCAL aTriangles      := ::Triangles
LOCAL aPoints         := ::aPoints

   IF ::lRunning = .T.
      RETURN NIL
   ENDIF

   IF LEN( aTriangles ) <> ::TrianglesCount
      ASIZE( aTriangles, ::TrianglesCount )
   ENDIF

   IF .NOT. FILE( "TRIMEMO.DBF" )
      CRE_TRIPLEMEMO( "TRIMEMO.DBF" )
   ENDIF
   USE TRIMEMO.DBF EXCLUSIVE VIA "DBFCDX"
   ZAP
   APPEND BLANK

   REPLACE TRIMEMO->TPOINTS WITH HB_Serialize( aPoints )              // Var2Bin()
   REPLACE TRIMEMO->TRIANGLE WITH HB_Serialize( aTriangles )          // Var2Bin()
   //   REPLACE TRIMEMO->RIBS      WITH HB_Serialize()            // Var2Bin()
   CLOSE TRIMEMO

   IF .NOT. FILE( "TPOINTS.DBF" )
      CRE_POINTS( "TPOINTS.DBF" )
   ENDIF
   USE TPOINTS.DBF EXCLUSIVE VIA "DBFCDX"
   ZAP

   FOR i := 1 TO LEN( aPoints )
      APPEND BLANK

      REPLACE TPOINTS->NUM WITH i
      REPLACE TPOINTS->PX WITH aPoints[ i ] .gx
      REPLACE TPOINTS->PY WITH aPoints[ i ] .yy
      REPLACE TPOINTS->PZ WITH aPoints[ i ] .zz
      REPLACE TPOINTS->COLOR WITH RGB2Num( aPoints[ i ] .Color )
   NEXT
   CLOSE TPOINTS

   IF .NOT. FILE( "RIBS.DBF" )
      CRE_RIBS( "RIBS.DBF" )
   ENDIF
   USE RIBS.DBF EXCLUSIVE VIA "DBFCDX"
   ZAP

   FOR j := 1 TO nTrianglesCount

      IF aTriangles[ j ] .gx * aTriangles[ j ] .yy * aTriangles[ j ] .zz = 0
         EXIT
      ELSE
         APPEND BLANK

         REPLACE RIBS->NUM WITH j
         REPLACE RIBS->PX1 WITH aPoints[ aTriangles[ j ] .gx ] .x
         REPLACE RIBS->PY1 WITH aPoints[ aTriangles[ j ] .gx ] .y
         REPLACE RIBS->PX2 WITH aPoints[ aTriangles[ j ] .yy ] .x
         REPLACE RIBS->PY2 WITH aPoints[ aTriangles[ j ] .yy ] .y
         REPLACE RIBS->PX3 WITH aPoints[ aTriangles[ j ] .zz ] .x
         REPLACE RIBS->PY3 WITH aPoints[ aTriangles[ j ] .zz ] .y

         REPLACE RIBS->COLOR1 WITH RGB2Num( aPoints[ aTriangles[ j ] .gx ] .Color )
         REPLACE RIBS->COLOR2 WITH RGB2Num( aPoints[ aTriangles[ j ] .yy ] .Color )
         REPLACE RIBS->COLOR3 WITH RGB2Num( aPoints[ aTriangles[ j ] .zz ] .Color )
         //  RibID
         //  REPLACE RIBS->PID    WITH ::aRibID

      ENDIF
   NEXT
   CLOSE RIBS

   IF .NOT. FILE( "TRIANGLE.DBF" )
      CRE_TRIANGLE( "TRIANGLE.DBF" )
   ENDIF
   USE TRIANGLE.DBF EXCLUSIVE VIA "DBFCDX"
   ZAP

   FOR j := 1 TO nTrianglesCount

      IF aTriangles[ j ] .gx * aTriangles[ j ] .yy * aTriangles[ j ] .zz = 0
         EXIT
      ELSE
         APPEND BLANK
         REPLACE TRIANGLE->NUM WITH j
         REPLACE TRIANGLE->gx WITH aTriangles[ j ] .gx
         REPLACE TRIANGLE->YY WITH aTriangles[ j ] .yy
         REPLACE TRIANGLE->ZZ WITH aTriangles[ j ] .zz
      ENDIF
   NEXT
   CLOSE TRIANGLE

   MSGInfo( "save " + LTRIM( STR( ::PointsCount ) ) + " points" + CRLF + ;
            "Ribs " + LTRIM( STR( nTrianglesCount ) ) + " Triangles", "Save Data" )
RETURN NIL

METHOD TimeGlassOn( oXbp, lChild ) CLASS DemoForm

RETURN NIL

METHOD TimeGlassOff( oXbp, lChild ) CLASS DemoForm

RETURN NIL

METHOD Distance( aPos1, aPos2 ) CLASS DemoForm
LOCAL nLen := LEN( aPos1 ), i, nTotal

   /* For 1,2,3, or notional Dimensions, perform a Distance calculation */
   nTotal := 0
   FOR i := 1 TO LEN( aPos1 )
      nTotal += ( ( aPos1[ i ] - aPos2[ i ] ) ^ 2 )
   NEXT i

RETURN SQRT( nTotal )

METHOD SetMaxPoints( nPointsCount ) CLASS DemoForm

   IF VALTYPE( nPointsCount ) = "N" .AND. nPointsCount <= 10000
      ::pointsCount := nPointsCount
      ::UserPoints := nPointsCount
   ELSE
      MsgInfo( "too much Points " + STR( nPointsCount ) + CRLF + "max. 10.000" )
   ENDIF
RETURN self

METHOD xOnPaint( nHwnd ) CLASS DemoForm

LOCAL hDC, pps := REPLICATE( CHR( 0 ), 64 )
LOCAL nWidth  := GetProperty( "MainForm", "Width" )
LOCAL nHeight := GetProperty( "MainForm", "Height" )

   IF lDemoRun = .T.
      IF ::lFlagEdge = .F.
         hDC := BeginPaint( nHwnd, @pps )
         FillGradientEx( hDC, { nWidth, 0, 250, 0, 0 }, { nWidth, nHeight, 0, 250, 0 }, { 0, nHeight, 0, 0, 250 } )
         EndPaint( nHwnd, pps )
      ENDIF
   ENDIF
RETURN Nil

METHOD DoSetup() CLASS DemoForm

   OpenDLTSETUP()
#IFDEF Use_FMG
   IF !IsWindowDefined( DLTSETUP )
      Load Window DLTSETUP
      ON KEY ESCAPE OF DLTSETUP ACTION DLTSETUP.Release
      DLTSETUP.Text_SizeX.Value := DLTSETUP->SIZEX
      DLTSETUP.Text_SizeY.Value := DLTSETUP->SIZEY
      DLTSETUP.Text_Points.Value := DLTSETUP->TPOINTS
      DLTSETUP.CheckBox_004.Value := DLTSETUP->EDGE                   // edge
      DLTSETUP.CheckBox_005.Value := DLTSETUP->QUICK                  // quick
      DLTSETUP.CheckBox_006.Value := DLTSETUP->SMOOTH                 // smooth
      DLTSETUP.CheckBox_007.Value := DLTSETUP->CIRCLE                 // Circle

      CENTER WINDOW DLTSETUP
      Activate Window DLTSETUP
   ENDIF
#ELSE
   SETUPFORM()
#ENDIF
   CloseDLTSETUP()

RETURN Nil

METHOD InitFromDBF() CLASS DemoForm

   OpenDLTSETUP()

   SetProperty( "MainForm", "Width", DLTSETUP->SIZEX )
   SetProperty( "MainForm", "Height", DLTSETUP->SIZEY )
   ::pointsCount := DLTSETUP->TPOINTS
   ::lFlagEdge := DLTSETUP->EDGE
   ::lRibQuick := DLTSETUP->QUICK
   ::lFlagSmooth := DLTSETUP->SMOOTH
   ::lFlagCircle := DLTSETUP->CIRCLE

   CloseDLTSETUP()

RETURN Nil

METHOD FindDistance( zzz, p1, p2 ) CLASS DemoForm

LOCAL ii, iMax := LEN( ::apoints )
LOCAL x1, y1, nDistance, nMin := 10000000
LOCAL nPosi := 0, nItem := zzz

   ALTD()

   FOR ii := 1 TO iMax
      x1 := ::apoints[ ii ] [ 1 ]
      y1 := ::apoints[ ii ] [ 2 ]
      nDistance := ::Distance( { p1, p2 }, { x1, y1 } )
      ::aDistance[ zzz ] [ ii ] := nDistance
      IF !EMPTY( nDistance )
         nMin := MIN( nMin, nDistance )
      ENDIF
   NEXT

   nPosi := ASCAN( ::aDistance[ zzz ], { | e | e = nMin } )
   IF nPosi > 0
      nItem := nPosi
   ENDIF

RETURN nItem

*+--------------------------------------------------------------------
*+
*+    Static Function OpenDLTSETUP()
*+
*+    Called from ( hbdlt.prg )   2 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION OpenDLTSETUP()

LOCAL lRet := .T.
   SELECT 99
   USE DLTSETUP.DBF ALIAS DLTSETUP EXCLUSIVE
   IF NETERR()
      lRet := .F.
   ELSE
      //  SET INDEX TO DLTSETUP.CDX
   ENDIF
RETURN lRet

*+--------------------------------------------------------------------
*+
*+    Static Procedure CloseDLTSETUP()
*+
*+    Called from ( hbdlt.prg )   2 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CloseDLTSETUP()

   SELECT 99
   IF USED()
      CLOSE
   ENDIF
   SELECT 1
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure DoEndObj()
*+
*+    Called from ( hbdlt.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE DoEndObj()

   IF !EMPTY( oDemoForm )
      oDemoForm:lbreak := .T.
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function CRE_POINTS()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CRE_POINTS( datei, alias, id )

LOCAL p, field_list := {}
   IF VALTYPE( datei ) != "C"
      datei := "TPOINTS.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT ( id )
   IF !FILE( datei )
      AADD( field_list, { "NUM", "N", 5, 0 } )
      AADD( field_list, { "PX", "N", 5, 0 } )
      AADD( field_list, { "PY", "N", 5, 0 } )
      AADD( field_list, { "PZ", "N", 5, 0 } )
      AADD( field_list, { "COLOR", "N", 10, 0 } )
      DBCREATE( datei, field_list, "DBFCDX" )
   ENDIF
RETURN ( .t. )

*+--------------------------------------------------------------------
*+
*+    Static Function CRE_RIBS()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CRE_RIBS( datei, alias, id )

LOCAL p, field_list := {}
   IF VALTYPE( datei ) != "C"
      datei := "RIBS.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT ( id )
   IF !FILE( datei )
      AADD( field_list, { "NUM", "N", 5, 0 } )
      AADD( field_list, { "PX1", "N", 5, 0 } )
      AADD( field_list, { "PY1", "N", 5, 0 } )
      AADD( field_list, { "PX2", "N", 5, 0 } )
      AADD( field_list, { "PY2", "N", 5, 0 } )
      AADD( field_list, { "PX3", "N", 5, 0 } )
      AADD( field_list, { "PY3", "N", 5, 0 } )
      AADD( field_list, { "COLOR1", "N", 10, 0 } )
      AADD( field_list, { "COLOR2", "N", 10, 0 } )
      AADD( field_list, { "COLOR3", "N", 10, 0 } )
      AADD( field_list, { "PID", "C", 20, 0 } )
      DBCREATE( datei, field_list, "DBFCDX" )
   ENDIF
RETURN ( .t. )

*+--------------------------------------------------------------------
*+
*+    Static Function CRE_TRIANGLE()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CRE_TRIANGLE( datei, alias, id )

LOCAL p, field_list := {}
   IF VALTYPE( datei ) != "C"
      datei := "TRIANGLE.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT ( id )
   IF !FILE( datei )
      AADD( field_list, { "NUM", "N", 5, 0 } )
      AADD( field_list, { "gx", "N", 5, 0 } )
      AADD( field_list, { "YY", "N", 5, 0 } )
      AADD( field_list, { "ZZ", "N", 5, 0 } )
      DBCREATE( datei, field_list, "DBFCDX" )
   ENDIF
RETURN ( .t. )

*+--------------------------------------------------------------------
*+
*+    Static Function CRE_TRIPLEMEMO()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CRE_TRIPLEMEMO( datei, alias, id )

LOCAL p, field_list := {}
   IF VALTYPE( datei ) != "C"
      datei := "TRIMEMO.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT ( id )
   IF !FILE( datei )
      AADD( field_list, { "NUM", "N", 5, 0 } )
      AADD( field_list, { "DESC", "C", 100, 0 } )
      AADD( field_list, { "TPOINTS", "M", 10, 0 } )
      AADD( field_list, { "RIBS", "M", 10, 0 } )
      AADD( field_list, { "TRIANGLE", "M", 10, 0 } )
      DBCREATE( datei, field_list, "DBFCDX" )
   ENDIF
RETURN ( .t. )

*+--------------------------------------------------------------------
*+
*+    Static Function CRE_Setup()
*+
*+    Called from ( hbdlt.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CRE_Setup( datei, alias, id )

LOCAL p, field_list := {}
   IF VALTYPE( datei ) != "C"
      datei := "DLTSETUP.DBF"
   ENDIF
   IF VALTYPE( alias ) != "C"
      p := AT( ".", datei )
      alias := IF( p > 0, SUBSTR( datei, 1, p - 1 ), datei )
   ENDIF
   IF VALTYPE( id ) != "N"
      id := 0
   ENDIF
   SELECT ( id )
   IF !FILE( datei )
      AADD( field_list, { "SIZEX", "N", 4, 0 } )
      AADD( field_list, { "SIZEY", "N", 4, 0 } )
      AADD( field_list, { "TPOINTS", "N", 4, 0 } )
      AADD( field_list, { "EDGE", "L", 1, 0 } )
      AADD( field_list, { "QUICK", "L", 1, 0 } )
      AADD( field_list, { "SMOOTH", "L", 1, 0 } )
      AADD( field_list, { "CIRCLE", "L", 1, 0 } )
      DBCREATE( datei, field_list, "DBFCDX" )
   ENDIF

   USE DLTSETUP.DBF EXCLUSIVE
   APPEND BLANK
   REPLACE SIZEX WITH 1024
   REPLACE SIZEY WITH 768
   REPLACE TPOINTS WITH 100
   REPLACE EDGE WITH .T.
   REPLACE QUICK WITH .T.
   REPLACE SMOOTH WITH .F.
   REPLACE CIRCLE WITH .F.
   CLOSE

RETURN ( .t. )

*+--------------------------------------------------------------------
*+
*+    Static Function RGB_COLOR()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RGB_COLOR()

LOCAL aRet := {}

   AADD( aRet, { 255, 000, 000 } )                                    // Red
   AADD( aRet, { 255, 128, 000 } )                                    // Red-Yellow
   AADD( aRet, { 255, 255, 000 } )                                    // Yello
   AADD( aRet, { 128, 255, 000 } )                                    // Yello-Green
   AADD( aRet, { 000, 255, 000 } )                                    // Green
   AADD( aRet, { 000, 255, 128 } )                                    // Green-Cyan
   AADD( aRet, { 000, 255, 255 } )                                    // Cyan
   AADD( aRet, { 000, 128, 255 } )                                    // Cyan-Blue
   AADD( aRet, { 000, 000, 255 } )                                    // Blue
   AADD( aRet, { 128, 000, 255 } )                                    // Blue-Pink
   AADD( aRet, { 255, 000, 255 } )                                    // Pink
   AADD( aRet, { 255, 000, 128 } )                                    // Pink-Red

RETURN aRet

*+--------------------------------------------------------------------
*+
*+    Static Function Winkel()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Winkel( a, b, c )

LOCAL n
   n := ( ( a * a ) + ( c * c ) - ( b * b ) ) / ( 2 * a * c )
RETURN n

*+--------------------------------------------------------------------
*+
*+    Static Function GraSaveScreen()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GraSaveScreen( oSourcePS, aPos, aSize )

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Procedure GraRestScreen()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE GraRestScreen( oTargetPS, aPos, oBitmap )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function VAR2CHAR()
*+
*+    Called from ( hbdlt.prg )   2 - static function ondummy()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION VAR2CHAR( cIn )                                       // Jimmy

LOCAL cOut := hb_valToExp( cIn )
RETURN STRTRAN( cOut, '"', '' )

*+--------------------------------------------------------------------
*+
*+    Static Procedure SbarText()
*+
*+    Called from ( hbdlt.prg )   7 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE SbarText( cText, cIcon )

   MainForm.StatusBar.Item( 1 ) := cText
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function onDummy()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION onDummy()

LOCAL iMax   := PCOUNT()
LOCAL i
LOCAL cText  := ""
LOCAL xValue

   IF lDebug = .T.
      FOR i := 1 TO iMax - 1
         cText += Var2Char( PValue( i ) ) + CHR( 9 )
      NEXT
      cText += Var2Char( PValue( iMax ) )

      IF EMPTY( cText )
         cText := TIME() + " no Parameter ? " + CRLF + PROCNAME( 1 ) + STR( PROCLINE( 1 ) ) + CRLF + PROCNAME( 2 ) + STR( PROCLINE( 2 ) )
      ENDIF
      SET CONSOLE OFF
      SET ALTER ON

      ? cText

      SET ALTER OFF
      SET CONSOLE ON
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function RGB2Num()
*+
*+    Called from ( hbdlt.prg )   4 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RGB2Num( aColor )

RETURN RGB( aColor[ 1 ], aColor[ 2 ], aColor[ 3 ] )

*+--------------------------------------------------------------------
*+
*+    Static Function RGB2BGR()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RGB2BGR( aColor )

RETURN { aColor[ 3 ], aColor[ 2 ], aColor[ 1 ] }

*+--------------------------------------------------------------------
*+
*+    Static Function NumColor2RGB()
*+
*+    Called from ( hbdlt.prg )   2 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION NumColor2RGB( nColor )

LOCAL aRetVal

   DEFAULT nColor TO - 1

   IF nColor == - 1
      aRetVal := { NIL, NIL, NIL }
   ELSE
      aRetVal := { GetRed( nColor ), GetGreen( nColor ), GetBlue( nColor ) }
   ENDIF

RETURN aRetVal

//EOF
/////

*+ EOF: HBDLT.PRG