*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\DLT\\HBINPUT.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function GetInPut()
*+               Static Function GetInputValue()
*+
*+    Reformatted by Click! 2.05.30 on Jun-29-2020 at 12:05 am
*+
*+--------------------------------------------------------------------

#include "HMG.CH"
#include "common.CH"

MEMVAR _HMG_SYSDATA

*+--------------------------------------------------------------------
*+
*+    Function GetInPut()
*+
*+    Called from ( hbdlt.prg )   1 - create class demoform()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetInPut( cLabel, cTitle, xValue, nIcon )

LOCAL cRet  := ""
LOCAL cType

   DEFAULT nIcon TO 1

   IF VALTYPE( xValue ) = "N"
      cType := "NUMERIC"
   ELSE
      cType := "CHARACTER"
   ENDIF

   DEFINE WINDOW GetInPut ;
              AT 0, 50 ;
              WIDTH 330 ;
              HEIGHT 170 ;
              TITLE cTitle ;
              ICON IF( nIcon = 1, "ICOFOLDER", "ICOSEARCH" ) ;
              NOMAXIMIZE ;
              NOMINIMIZE ;
              TOPMOST ;
              BACKCOLOR nil

      DEFINE LABEL Label_1
         ROW 10
         COL 10
         WIDTH 300
         HEIGHT 30
         VALUE cLabel
         FONTNAME "Arial"
         FONTSIZE 9
         VISIBLE .T.
         BACKCOLOR nil
         FONTCOLOR nil
      END LABEL

      DEFINE TEXTBOX Text_1
         ROW 50
         COL 10
         WIDTH 300
         HEIGHT 30
         FONTNAME "Arial"
         FONTSIZE 9
         ONENTER GetInputValue( @cRet )
         TABSTOP .T.
         VISIBLE .T.
         READONLY .F.
         DISABLEDBACKCOLOR Nil
         DISABLEDFONTCOLOR Nil
         CASECONVERT NONE
         BACKCOLOR nil
         FONTCOLOR nil
         INPUTMASK Nil
         FORMAT Nil
         IF VALTYPE( xValue ) = "N"
            DATATYPE NUMERIC
         ELSE
            DATATYPE CHARACTER
         ENDIF
         VALUE xValue
      END TEXTBOX

      DEFINE BUTTON Button_OK
         ROW 90
         COL 10
         WIDTH 100
         HEIGHT 30
         ACTION GetInputValue( @cRet )
         CAPTION "&OK"
         FONTNAME "Arial"
         FONTSIZE 9
         TABSTOP .T.
         VISIBLE .T.
         PICTURE "MYOK"
         PICTALIGNMENT LEFT
      END BUTTON

      DEFINE BUTTON Button_Abort
         ROW 90
         COL 210
         WIDTH 100
         HEIGHT 30
         ACTION GetInPut.Release
         CAPTION "&Abort"
         FONTNAME "Arial"
         FONTSIZE 9
         TABSTOP .T.
         VISIBLE .T.
         PICTURE "MYEXIT"
         PICTALIGNMENT LEFT
      END BUTTON

   END WINDOW

   ON KEY ESCAPE OF GetInPut ACTION GetInPut.Release
   CENTER WINDOW GetInPut
   GetInPut.Text_1.setfocus()
   ACTIVATE WINDOW GetInPut

RETURN cRet

*+--------------------------------------------------------------------
*+
*+    Static Function GetInputValue()
*+
*+    Called from ( hbinput.prg )   2 - function getinput()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GetInputValue( cRet )

   cRet := GetInPut.Text_1.Value
   GetInPut.Release
RETURN NIL

//
//
//

*+ EOF: HBINPUT.PRG
